Commit 96602be4 authored by Michael Hanselmann's avatar Michael Hanselmann

Add script to check version format

Only versions of the format “x.y.z” and “x.y.z~(rc|beta)N” (for N>0) are
allowed.
Signed-off-by: default avatarMichael Hanselmann <hansmi@google.com>
Reviewed-by: default avatarIustin Pop <iustin@google.com>
parent 577b170b
......@@ -15,6 +15,7 @@ BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
CHECK_MAN = $(top_srcdir)/autotools/check-man
CHECK_VERSION = $(top_srcdir)/autotools/check-version
REPLACE_VARS_SED = autotools/replace_vars.sed
hypervisordir = $(pkgpythondir)/hypervisor
......@@ -283,6 +284,7 @@ EXTRA_DIST = \
autotools/check-python-code \
autotools/check-man \
autotools/check-tar \
autotools/check-version \
autotools/docbook-wrapper \
autotools/gen-coverage \
autotools/testrunner \
......@@ -636,6 +638,7 @@ check-dirs: $(BUILT_SOURCES)
check-local: check-dirs
$(CHECK_PYTHON_CODE) $(check_python_code)
$(CHECK_VERSION) $(VERSION)
.PHONY: lint
lint: ganeti $(BUILT_SOURCES)
......
#!/bin/bash
#
# Copyright (C) 2010 Google Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
set -e
# Enable Bash-specific patterns
shopt -s extglob
readonly version=$1
readonly numpat='+([0-9])'
case "$version" in
# Format "x.y.z"
$numpat.$numpat.$numpat) : ;;
# Format "x.y.z~rcN" or "x.y.z~betaN" for N > 0
$numpat.$numpat.$numpat~@(rc|beta)[1-9]*([0-9])) : ;;
*)
echo "Invalid version format: $version" >&2
exit 1
;;
esac
readonly newsver="Version ${version/~/}"
if ! grep -q -x "$newsver" NEWS
then
echo "Unable to find heading '$newsver' in NEWS" >&2
exit 1
fi
exit 0
Markdown is supported
0% or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment